
#ifndef OVERLAY_H
#define OVERLAY_H

#include "png_wrap.h"
#include "globals.h"

typedef struct overlay_type
{
	int appear,
	    intime,
	    incount,
	    disappear,
	    outtime,
	    outcount;
	PNG *piccy;
	int startx,
	    starty,
	    endx,
	    endy;
} OVERLAY;

void overlaypart(buftype *pic,buftype *ovl,int x,int y,int w,int h);
void overlay(buftype *pic,OVERLAY *ovl);

#endif
